#ifndef HOTKEYLISTENER_H
#define HOTKEYLISTENER_H

// Qt Includes
#include <QObject>
#include <QWidget>
#include <QApplication>
#include <QLocalSocket>

// Qxt Includes
#include <QxtGlobalShortcut>

class HotKeyListener : public QObject
{
    Q_OBJECT
public:
    explicit HotKeyListener(QObject *parent = 0);

    ~HotKeyListener();

private:
    QLocalSocket* localSocket;
    QByteArray incomingDataBuffer;
    QHash<QxtGlobalShortcut*, QString> shortcuts;
    bool connected;

    // Connect all signals at initialization
    void connectSignals();

signals:
    void gotCommand(QString command);

public slots:

private slots:
    // Send message indicating shortcuts have been fired
    void fireShortcut();

    // Handles errors from the local socket
    void handleError(QLocalSocket::LocalSocketError error);

    // Handles the connected message from the local socket
    void handleConnected();

    // Handles incoming data from the local socket
    void incomingData();
};

#endif // HOTKEYLISTENER_H
